/**
 * Based on examples in
 *     Head First Object-Oriented Analysis and Design
 *     by Brett D. McLaughlin, Gary Pollice, and David West
 *     O'Reilly, 2007
 *     ISBN 978-0-596-00867-3
 *
 * Ported from Java by
 *     Ronald Mak
 *     Department of Computer Engineering
 *     San Jose State University
 *     San Jose, CA  95192
 */
#include <string>
#include "GuitarSpec.h"
#include "InstrumentSpec.h"
#include "Builder.h"
#include "Type.h"
#include "Wood.h"

using namespace std;

bool GuitarSpec::matches(InstrumentSpec *other_spec)
{
    if (typeid(other_spec) != typeid(GuitarSpec)) return false;
    if (!InstrumentSpec::matches(other_spec)) return false;

    GuitarSpec *guitar_spec = dynamic_cast<GuitarSpec *>(other_spec);

    return (guitar_spec != nullptr)
        && (string_count == guitar_spec->string_count);
}
