/**
 * Based on examples in
 *     Head First Object-Oriented Analysis and Design
 *     by Brett D. McLaughlin, Gary Pollice, and David West
 *     O'Reilly, 2007
 *     ISBN 978-0-596-00867-3
 *
 * Ported from Java by
 *     Ronald Mak
 *     Department of Computer Engineering
 *     San Jose State University
 *     San Jose, CA  95192
 */
#ifndef INSTRUMENT_H_
#define INSTRUMENT_H_

#include <string>
#include "InstrumentSpec.h"

using namespace std;

class Instrument
{
public:
    Instrument(string serial_number, double price, InstrumentSpec *spec)
        : serial_number(serial_number), price(price), spec(spec)
    {}

    virtual ~Instrument() = 0;

    string get_serial_number() const        { return serial_number; }
    double get_price() const                { return price; }
    void   set_price(const float new_price) { price = new_price; }
    InstrumentSpec *get_spec() const        { return spec; }

private:
    string serial_number;
    double price;
    InstrumentSpec *spec;
};

inline Instrument::~Instrument() {}

#endif /* INSTRUMENT_H_ */
