/**
 * Based on examples in
 *     Head First Object-Oriented Analysis and Design
 *     by Brett D. McLaughlin, Gary Pollice, and David West
 *     O'Reilly, 2007
 *     ISBN 978-0-596-00867-3
 *
 * Ported from Java by
 *     Ronald Mak
 *     Department of Computer Engineering
 *     San Jose State University
 *     San Jose, CA  95192
 */
#include <string>
#include "MandolinSpec.h"
#include "InstrumentSpec.h"
#include "Builder.h"
#include "Type.h"
#include "Wood.h"

using namespace std;

bool MandolinSpec::matches(InstrumentSpec *other_spec)
{
    if (typeid(other_spec) != typeid(MandolinSpec)) return false;
    if (!InstrumentSpec::matches(other_spec)) return false;

    MandolinSpec *mandolin_spec = dynamic_cast<MandolinSpec *>(other_spec);

    return (mandolin_spec != nullptr)
        && (style == mandolin_spec->style);
}
